package com.qmth.teachcloud.common.mapper;

import com.qmth.teachcloud.common.bean.dto.TBSyncTaskDto;
import com.qmth.teachcloud.common.enums.PushTypeEnum;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @Description: 推送任务共用mapper
 * @Author: CaoZixuan
 * @Date: 2022-08-03
 */
public interface CloudUserPushOperateMapper {
    /**
     * 新增推送任务
     *
     * @param tbSyncTaskDto tbSyncTaskDto
     * @return 是否成功
     */
    boolean insertTBSyncTask(@Param("tbSyncTaskDto") TBSyncTaskDto tbSyncTaskDto);

    /**
     * 更新推送任务
     *
     * @param tbSyncTaskDto tbSyncTaskDto
     * @return 是否成功
     */
    boolean updateTBSyncTask(@Param("tbSyncTaskDto") TBSyncTaskDto tbSyncTaskDto);

    /**
     * 根据id查询
     *
     * @param id id
     * @return 结果
     */
    TBSyncTaskDto findById(@Param("id") Long id);

    /**
     * 查找推送记录
     *
     * @param schoolId  学校id
     * @param objectId 关联用户id
     * @param type      推送类型
     * @return 推送任务集合（应该只有一条）
     */
    List<TBSyncTaskDto> findPushRecord(@Param("schoolId") Long schoolId, @Param("objectId") Long objectId, @Param("type") String type);
}
