package com.qmth.teachcloud.common.service;

import com.qmth.teachcloud.common.bean.dto.TBSyncTaskDto;
import com.qmth.teachcloud.common.bean.params.UserPushParam;
import com.qmth.teachcloud.common.entity.SysUser;

import java.util.List;
import java.util.Map;

/**
 * @Description: 推送任务服务类
 * @Author: CaoZixuan
 * @Date: 2022-08-03
 */
public interface CloudUserPushOperateService {
    /**
     * 新增或更新推送任务
     *
     * @param tbSyncTaskDto obj
     */
    void saveOrUpdateTBSyncTask(TBSyncTaskDto tbSyncTaskDto);

    /**
     * 查询用户推送记录
     *
     * @param userId   用户id
     * @param schoolId 学校id
     * @return 记录
     */
    TBSyncTaskDto findUserPushRecord(Long userId, Long schoolId);


    /**
     * 初始化用户推送任务
     *
     * @param userPushMap 用户map
     * @param requestUser 请求用户
     */
    void initUserPushTasks(Map<Long, List<UserPushParam>> userPushMap, SysUser requestUser);

    /**
     * 用户推送任务进行中
     *
     * @param userId      用户id
     * @param requestUser 请求用户
     * @return 。。
     */
    TBSyncTaskDto runningUserPushTask(Long userId, SysUser requestUser);
}
